#define PORT 43311
#include <netdb.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <iostream>
#include <errno.h>
#include <sstream>

#include "common.h"

using namespace std;

int main(int argc, char **argv)
{
    int server = socket(AF_INET,SOCK_STREAM,0);
	if(server == -1) {
  		cerr << "Opening stream socket failed. ERROR:" << errno << endl;
  		return -1;
	}

	struct sockaddr_in server_name;
	server_name.sin_family = AF_INET;
	server_name.sin_addr.s_addr=INADDR_ANY;
	server_name.sin_port = htons(PORT);
	memset(&(server_name.sin_zero),'\0',8);
    int _set=1;
    int iResult = setsockopt(server, SOL_SOCKET, SO_REUSEADDR, (char *) &_set, sizeof(int));
    if (iResult == -1) {
        cerr << "The call of setsockopt failed with error:" << errno << endl;
    } else {
        cerr << "\t\tSet SO_REUSEADDR: ON" << endl;
    }

	if( bind(server, (struct sockaddr *) &server_name, sizeof server_name ) == -1 ) {
    	cerr << "Binding stream socket failed." << endl;
    	return -1;
	}

	{
        struct sockaddr_in server_info;
        socklen_t _length = sizeof(server_info);
        if( getsockname( server, (struct sockaddr *) &server_info, &_length) == -1 ) {
            cerr << "Getting socket failed." << endl;
        }
        cout << "\t------------------------------------------------------" << endl;
        cout << "\t--> IPv4 Address is " << inet_ntoa(server_info.sin_addr) << endl;
        cout << "\t--> Port number is " << ntohs(server_info.sin_port) << endl;
        cout << "\t------------------------------------------------------" << endl;
	}

	if(listen(server,4)==-1) {
		cerr << "Listening failed to start." << endl;
		return -1;
	}
    cout << "\t>> Server is ready to accept incomming calls." << endl;

    while (true) {
        int i;
        string host_name;
        // Blokkol, amíg nincs beérkező hívás.
        struct sockaddr_in caller;
        socklen_t addrlen = sizeof(caller);
        int call = accept(server,(struct sockaddr *) &caller, &addrlen);

	ReqMsg msg;
	ReplyMsg reply;
	
	for (;;) {
		if (recv(call, &msg, sizeof(msg),0) <= 0) {
			printf("Client closed the connection...\n");
			close(call);
			break;
		}

		printf("%d %c %d =???\n", msg.a, msg.op, msg.b);

		switch(msg.op) {
		case '+': 	reply.result = msg.a + msg.b;
				break;
		case '*': 	reply.result = msg.a * msg.b;
				break;
		}
		send(call, &reply, sizeof(reply), 0);
	}

    }
    close(server);

    
    cout << " << Server is now terminating." << endl;
    return 0;
}
